【3】题解:P12195 [NOISG 2025 Prelim] Itinerary
题目大意:对于所有的 \(n\) 个点,是否可以以 \(i\) 点为起点走一条欧拉序列,使得给定的序列是其子序列。
我们发现题目给定的是树结构。这时候,走进一个子树就必须走完子树,才能出来。这时,当我们发现有一点访问次数 \(>2\),显然就不合法了。我们把访问拆分成入访问和出访问。当曾经进入过一个子树,那么我们就不能再次进入。同理,当曾经离开过一个子树,那么我们就不能再次离开。出现这种情况,也就是节点死了,那么我们就要全部输出 \(0\)。(笑点解析:全部输出 \(0\) 可以通过 \(\frac{1}{3}\) 的点)
考虑枚举每一组相邻的有活动的城市,\(s_{i-1}\) 和 \(s_i\)。发现不乱走的话必须走最近公共祖先。那么我们直接暴力走(我们注意到每个点最多走 \(2\) 次),我们 \(s_{i-1}\) 跳最近公共祖先时贡献到来信息。当这个点只出不入,也就是之前走的时候更新过这个点的离开信息,那么这个的子树出发就会出现无法按照顺序到达的子树,就不合法了,标记。同理我们还有 \(s_{i}\) 往回走最近公共祖先贡献离开信息,当这个点只入不出,也不合法。
代码如下:
#include<bits/stdc++.h>
using namespace std;
const int N=2e5+10;
int n,m,s[N<<2];
vector<int>e[N];
int top[N],sz[N],son[N],id[N],dep[N],fat[N];
int ic;
bool vis[N][2],mrk[N];
void dfs(int p,int fa){
sz[p]=1;
id[p]=++ic;
fat[p]=fa;
for(auto v:e[p]){
if(v^fa){
dep[v]=dep[p]+1;
dfs(v,p);
sz[p]+=sz[v];
if(sz[v]>sz[son[p]])
son[p]=v;
}
}
}
void dfs2(int p,int tp){
top[p]=tp;
if(son[p])
dfs2(son[p],tp);
for(auto v:e[p]){
if(v^fat[p]&&v^son[p]){
dfs2(v,v);
}
}
return;
}
int LCA(int u,int v){
while(top[u]!=top[v]){
if(dep[top[u]]<dep[top[v]])
swap(u,v);
u=fat[top[u]];
}
if(dep[u]>dep[v])
swap(u,v);
return u;
}
void mtree(int p,int fa){
mrk[p]=1;
for(auto v:e[p]){
if(v^fa&&!mrk[v]){
mtree(v,p);
}
}
}
int main(){
cin>>n>>m;
for(int i=1;i<n;i++){
int u,v;
cin>>u>>v;
e[u].push_back(v);
e[v].push_back(u);
}
dfs(1,0);
dfs2(1,1);
for(int i=1;i<=m;i++){
cin>>s[i];
}
for(int i=2;i<=m;i++){
int lca=LCA(s[i],s[i-1]);
int u=s[i-1],v=s[i];
while(u^lca){
if(vis[u][0]){
for(int j=1;j<=n;j++){
cout<<0<<"\n";
}
return 0;
}
if(vis[u][1]){
mtree(u,fat[u]);
}else{
vis[u][0]=1;
}
u=fat[u];
}
while(v^lca){
if(vis[v][1]){
for(int j=1;j<=n;j++){
cout<<0<<"\n";
}
return 0;
}
if(vis[v][0]){
mtree(fat[v],v);
}else{
vis[v][1]=1;
}
v=fat[v];
}
}
for(int i=1;i<=n;i++){
if(mrk[i])
cout<<0<<"\n";
else
cout<<1<<"\n";
}
return 0;
}
文章同步载入于洛谷,详见文章下方链接。
本文来自博客园,作者:Ivan422,转载请注明原文链接:https://www.cnblogs.com/Exfish/p/23277165。

浙公网安备 33010602011771号